var Activity = require('android.app.Activity');

var GoogleSignIn = require("com.google.android.gms.auth.api.signin.GoogleSignIn");

var Fitness = require("com.google.android.gms.fitness.Fitness");

var FitnessOptions = require("com.google.android.gms.fitness.FitnessOptions");

var DataType = require('com.google.android.gms.fitness.data.DataType');

var DataReadRequest = require('com.google.android.gms.fitness.request.DataReadRequest');

var DataReadResponse = require('com.google.android.gms.fitness.result.DataReadResponse');

var Calendar = require('java.util.Calendar');

var TimeUnit = require('java.util.concurrent.TimeUnit');

var OnCompleteListener = require('com.google.android.gms.tasks.OnCompleteListener');

var OnSuccessListener = require('com.google.android.gms.tasks.OnSuccessListener');

var OnFailureListener = require('com.google.android.gms.tasks.OnFailureListener');

var REQUEST_OAUTH_REQUEST_CODE = 1;

var fitnessOptions, windowActivity;

(function constructor() {
    fitnessOptions = FitnessOptions.builder()
        .addDataType(DataType.TYPE_ACTIVITY_SEGMENT, FitnessOptions.ACCESS_READ)
        .build();
})();

exports.start = function(activity) {
    windowActivity = new Activity(activity);

    windowActivity.onActivityResult = function(requestCode, resultCode, intent) {
        console.log("result: " + requestCode);
    };

    if (!GoogleSignIn.hasPermissions(GoogleSignIn.getLastSignedInAccount(windowActivity), fitnessOptions)) {
        GoogleSignIn.requestPermissions(
            windowActivity,
            REQUEST_OAUTH_REQUEST_CODE,
            GoogleSignIn.getLastSignedInAccount(windowActivity),
            fitnessOptions
        );
    } else {
        accessGoogleFit();
    }
}

function accessGoogleFit() {
    var cal = Calendar.getInstance();
    cal.setTime(new Date());

    var endTime = cal.getTimeInMillis();

    cal.add(Calendar.YEAR, -1);

    var startTime = cal.getTimeInMillis();

    console.log("startTime: " + startTime + "/ endTime: " + endTime);

    Fitness.getHistoryClient(windowActivity, GoogleSignIn.getLastSignedInAccount(windowActivity))
        .readData(new DataReadRequest.Builder()
            .read(DataType.TYPE_ACTIVITY_SEGMENT)
            .setTimeRange(startTime, endTime, TimeUnit.MILLISECONDS)
            .build())
        .addOnSuccessListener(new OnSuccessListener({
            onSuccess: function(e) {
                var dataResponse = new DataReadResponse(e);

                console.log("onSuccess()" + e.toString() + "/" + dataResponse.toString());
                console.log("getDataSets size: " + dataResponse.getDataSets().size());
            }
        }))
        .addOnFailureListener(new OnFailureListener({
            onFailure: function(e) {
                console.log("onFailure()");
            }
        }));
}
